<?xml version="1.0" encoding="utf-8"?>
<LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
    android:layout_width="match_parent"
    android:layout_height="match_parent"
    android:orientation="vertical"
    android:paddingBottom="@dimen/activity_padding_top"
    android:paddingLeft="@dimen/activity_padding_bottom"
    android:paddingRight="@dimen/activity_padding_left"
    android:paddingTop="@dimen/activity_padding_right">

    <LinearLayout
        android:layout_width="match_parent"
        android:layout_height="0dp"
        android:layout_weight="@integer/log_container_weight"
        android:orientation="vertical">

        <LinearLayout
            android:layout_width="match_parent"
            android:layout_height="0dp"
            android:layout_weight="1"
            android:orientation="horizontal">


            <EditText
                android:id="@+id/log"
                android:layout_width="0dp"
                android:layout_height="match_parent"
                android:layout_weight="1"
                android:background="@drawable/edit_text_bg"
                android:clickable="false"
                android:editable="false"
                android:gravity="top|left"
                android:longClickable="false"
                android:textSize="@dimen/log_text_size" />


            <ScrollView
                android:layout_width="wrap_content"
                android:layout_height="wrap_content"
                android:overScrollMode="never"
                android:scrollbars="none">

                <LinearLayout
                    android:layout_width="wrap_content"
                    android:layout_height="match_parent"
                    android:orientation="vertical">

                    <Button
                        android:id="@+id/settings"
                        android:layout_width="match_parent"
                        android:layout_height="@dimen/button_height"
                        android:text="@string/settings_title"
                        android:textSize="@dimen/button_text_size" />

                    <Button
                        android:id="@+id/save_log"
                        android:layout_width="match_parent"
                        android:layout_height="@dimen/button_height"
                        android:text="@string/save_log_title"
                        android:textSize="@dimen/button_text_size" />

                    <Button
                        android:id="@+id/clear"
                        android:layout_width="match_parent"
                        android:layout_height="@dimen/button_height"
                        android:text="@string/clear_title"
                        android:textSize="@dimen/button_text_size" />

                    <CheckBox
                        android:id="@+id/auto_clear"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:text="@string/auto_clear_title"
                        android:textSize="@dimen/check_box_text_size" />

                    <EditText
                        android:id="@+id/max_line"
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginLeft="@dimen/max_line_margin_left"
                        android:background="@drawable/edit_text_bg"
                        android:imeOptions="actionDone"
                        android:inputType="numberSigned"
                        android:singleLine="true"
                        android:textSize="@dimen/max_line_text_size" />

                </LinearLayout>
            </ScrollView>

        </LinearLayout>

        <LinearLayout
            android:layout_width="match_parent"
            android:layout_height="wrap_content"
            android:orientation="horizontal">

            <Spinner
                android:id="@+id/custom_commands"
                android:layout_width="0dp"
                android:layout_height="wrap_content"
                android:layout_gravity="center"
                android:layout_marginRight="@dimen/custom_commands_margin_right"
                android:layout_weight="1"
                android:background="@drawable/spinner_bg" />

            <Button
                android:id="@+id/custom_send"
                android:layout_width="wrap_content"
                android:layout_height="@dimen/button_height"
                android:layout_marginLeft="@dimen/custom_send_margin_left"
                android:text="@string/send_title"
                android:textSize="@dimen/button_text_size" />
        </LinearLayout>

    </LinearLayout>

    <LinearLayout
        android:layout_width="match_parent"
        android:layout_height="0dp"
        android:layout_weight="@integer/com_container_weight"
        android:orientation="vertical">

        <LinearLayout
            android:id="@+id/ab_com_container"
            android:layout_width="match_parent"
            android:layout_height="0dp"
            android:layout_marginRight="@dimen/double_container_margin_right"
            android:layout_weight="1"
            android:orientation="horizontal">

            <LinearLayout
                android:id="@+id/com_a_container"
                android:layout_width="0dp"
                android:layout_height="match_parent"
                android:layout_weight="1"
                android:layout_marginRight="@dimen/item_container_margin_right"
                android:orientation="vertical">

                <EditText
                    android:id="@+id/com_a_command"
                    android:layout_width="match_parent"
                    android:layout_height="0dp"
                    android:layout_weight="1"
                    android:background="@drawable/edit_text_bg"
                    android:gravity="top|left"
                    android:textSize="@dimen/command_edit_text_size" />

                <Spinner
                    android:id="@+id/com_a_port"
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_gravity="bottom"
                    android:layout_marginTop="@dimen/com_item_margin_top"
                    android:background="@drawable/spinner_bg" />

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_marginTop="@dimen/com_item_margin_top"
                    android:orientation="horizontal">

                    <Spinner
                        android:id="@+id/com_a_baud_rade"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center"
                        android:layout_weight="1"
                        android:background="@drawable/spinner_bg" />

                    <ToggleButton
                        android:id="@+id/com_a_toggle"
                        android:layout_width="@dimen/button_width"
                        android:layout_height="@dimen/button_height"
                        android:textSize="@dimen/button_text_size" />

                </LinearLayout>

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:orientation="horizontal">

                    <RadioGroup
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:orientation="horizontal">

                        <RadioButton
                            android:id="@+id/com_a_txt"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:text="@string/txt_title"
                            android:textSize="@dimen/radio_button_text_size" />

                        <RadioButton
                            android:id="@+id/com_a_hex"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:text="@string/hex_title"
                            android:textSize="@dimen/radio_button_text_size" />
                    </RadioGroup>

                    <CheckBox
                        android:id="@+id/com_a_line_break"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_weight="1"
                        android:text="@string/line_break_title"
                        android:textSize="@dimen/check_box_text_size" />
                </LinearLayout>

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:orientation="horizontal">

                    <EditText
                        android:id="@+id/com_a_send_delay"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_weight="1"
                        android:background="@drawable/edit_text_bg"
                        android:imeOptions="actionDone"
                        android:inputType="numberSigned"
                        android:singleLine="true"
                        android:textSize="@dimen/command_edit_text_size" />

                    <TextView
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_marginLeft="@dimen/time_unit_margin_left"
                        android:text="@string/time_unit_title"
                        android:textSize="@dimen/time_unit_text_size" />

                    <CheckBox
                        android:id="@+id/com_a_auto_send"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:text="@string/auto_title"
                        android:textSize="@dimen/check_box_text_size" />

                    <Button
                        android:id="@+id/com_a_send"
                        android:layout_width="@dimen/button_width"
                        android:layout_height="@dimen/button_height"
                        android:text="@string/send_title"
                        android:textSize="@dimen/button_text_size" />
                </LinearLayout>

            </LinearLayout>


            <LinearLayout
                android:id="@+id/com_b_container"
                android:layout_width="0dp"
                android:layout_height="match_parent"
                android:layout_weight="1"
                android:layout_marginLeft="@dimen/item_container_margin_left"
                android:orientation="vertical">

                <EditText
                    android:id="@+id/com_b_command"
                    android:layout_width="match_parent"
                    android:layout_height="0dp"
                    android:layout_weight="1"
                    android:background="@drawable/edit_text_bg"
                    android:gravity="top|left"
                    android:textSize="@dimen/command_edit_text_size" />

                <Spinner
                    android:id="@+id/com_b_port"
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_gravity="bottom"
                    android:layout_marginTop="@dimen/com_item_margin_top"
                    android:background="@drawable/spinner_bg" />

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_marginTop="@dimen/com_item_margin_top"
                    android:orientation="horizontal">

                    <Spinner
                        android:id="@+id/com_b_baud_rade"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center"
                        android:layout_weight="1"
                        android:background="@drawable/spinner_bg" />

                    <ToggleButton
                        android:id="@+id/com_b_toggle"
                        android:layout_width="@dimen/button_width"
                        android:layout_height="@dimen/button_height"
                        android:textSize="@dimen/button_text_size" />

                </LinearLayout>

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:orientation="horizontal">

                    <RadioGroup
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:orientation="horizontal">

                        <RadioButton
                            android:id="@+id/com_b_txt"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:text="@string/txt_title"
                            android:textSize="@dimen/radio_button_text_size" />

                        <RadioButton
                            android:id="@+id/com_b_hex"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:text="@string/hex_title"
                            android:textSize="@dimen/radio_button_text_size" />
                    </RadioGroup>

                    <CheckBox
                        android:id="@+id/com_b_line_break"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_weight="1"
                        android:text="@string/line_break_title"
                        android:textSize="@dimen/check_box_text_size" />
                </LinearLayout>

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:orientation="horizontal">

                    <EditText
                        android:id="@+id/com_b_send_delay"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_weight="1"
                        android:background="@drawable/edit_text_bg"
                        android:imeOptions="actionDone"
                        android:inputType="numberSigned"
                        android:singleLine="true"
                        android:textSize="@dimen/command_edit_text_size" />

                    <TextView
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_marginLeft="@dimen/time_unit_margin_left"
                        android:text="@string/time_unit_title"
                        android:textSize="@dimen/time_unit_text_size" />

                    <CheckBox
                        android:id="@+id/com_b_auto_send"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:text="@string/auto_title"
                        android:textSize="@dimen/check_box_text_size" />

                    <Button
                        android:id="@+id/com_b_send"
                        android:layout_width="@dimen/button_width"
                        android:layout_height="@dimen/button_height"
                        android:text="@string/send_title"
                        android:textSize="@dimen/button_text_size" />
                </LinearLayout>

            </LinearLayout>

        </LinearLayout>

        <LinearLayout
            android:id="@+id/cd_com_container"
            android:layout_width="match_parent"
            android:layout_height="0dp"
            android:layout_marginRight="@dimen/double_container_margin_right"
            android:layout_weight="1"
            android:orientation="horizontal">


            <LinearLayout
                android:id="@+id/com_c_container"
                android:layout_width="0dp"
                android:layout_height="match_parent"
                android:layout_weight="1"
                android:layout_marginRight="@dimen/item_container_margin_right"
                android:orientation="vertical">

                <EditText
                    android:id="@+id/com_c_command"
                    android:layout_width="match_parent"
                    android:layout_height="0dp"
                    android:layout_weight="1"
                    android:background="@drawable/edit_text_bg"
                    android:gravity="top|left"
                    android:textSize="@dimen/command_edit_text_size" />

                <Spinner
                    android:id="@+id/com_c_port"
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_gravity="bottom"
                    android:layout_marginTop="@dimen/com_item_margin_top"
                    android:background="@drawable/spinner_bg" />

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_marginTop="@dimen/com_item_margin_top"
                    android:orientation="horizontal">

                    <Spinner
                        android:id="@+id/com_c_baud_rade"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center"
                        android:layout_weight="1"
                        android:background="@drawable/spinner_bg" />

                    <ToggleButton
                        android:id="@+id/com_c_toggle"
                        android:layout_width="@dimen/button_width"
                        android:layout_height="@dimen/button_height"
                        android:textSize="@dimen/button_text_size" />

                </LinearLayout>

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:orientation="horizontal">

                    <RadioGroup
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:orientation="horizontal">

                        <RadioButton
                            android:id="@+id/com_c_txt"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:text="@string/txt_title"
                            android:textSize="@dimen/radio_button_text_size" />

                        <RadioButton
                            android:id="@+id/com_c_hex"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:text="@string/hex_title"
                            android:textSize="@dimen/radio_button_text_size" />
                    </RadioGroup>

                    <CheckBox
                        android:id="@+id/com_c_line_break"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_weight="1"
                        android:text="@string/line_break_title"
                        android:textSize="@dimen/check_box_text_size" />
                </LinearLayout>

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:orientation="horizontal">

                    <EditText
                        android:id="@+id/com_c_send_delay"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_weight="1"
                        android:background="@drawable/edit_text_bg"
                        android:imeOptions="actionDone"
                        android:inputType="numberSigned"
                        android:singleLine="true"
                        android:textSize="@dimen/command_edit_text_size" />

                    <TextView
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_marginLeft="@dimen/time_unit_margin_left"
                        android:text="@string/time_unit_title"
                        android:textSize="@dimen/time_unit_text_size" />

                    <CheckBox
                        android:id="@+id/com_c_auto_send"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:text="@string/auto_title"
                        android:textSize="@dimen/check_box_text_size" />

                    <Button
                        android:id="@+id/com_c_send"
                        android:layout_width="@dimen/button_width"
                        android:layout_height="@dimen/button_height"
                        android:text="@string/send_title"
                        android:textSize="@dimen/button_text_size" />
                </LinearLayout>

            </LinearLayout>


            <LinearLayout
                android:id="@+id/com_d_container"
                android:layout_width="0dp"
                android:layout_height="match_parent"
                android:layout_weight="1"
                android:layout_marginLeft="@dimen/item_container_margin_left"
                android:orientation="vertical">

                <EditText
                    android:id="@+id/com_d_command"
                    android:layout_width="match_parent"
                    android:layout_height="0dp"
                    android:layout_weight="1"
                    android:background="@drawable/edit_text_bg"
                    android:gravity="left|top"
                    android:textSize="@dimen/command_edit_text_size" />

                <Spinner
                    android:id="@+id/com_d_port"
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_gravity="bottom"
                    android:layout_marginTop="@dimen/com_item_margin_top"
                    android:background="@drawable/spinner_bg" />

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:layout_marginTop="@dimen/com_item_margin_top"
                    android:orientation="horizontal">

                    <Spinner
                        android:id="@+id/com_d_baud_rade"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center"
                        android:layout_weight="1"
                        android:background="@drawable/spinner_bg" />

                    <ToggleButton
                        android:id="@+id/com_d_toggle"
                        android:layout_width="@dimen/button_width"
                        android:layout_height="@dimen/button_height"
                        android:textSize="@dimen/button_text_size" />

                </LinearLayout>

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:orientation="horizontal">

                    <RadioGroup
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:orientation="horizontal">

                        <RadioButton
                            android:id="@+id/com_d_txt"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:text="@string/txt_title"
                            android:textSize="@dimen/radio_button_text_size" />

                        <RadioButton
                            android:id="@+id/com_d_hex"
                            android:layout_width="wrap_content"
                            android:layout_height="wrap_content"
                            android:text="@string/hex_title"
                            android:textSize="@dimen/radio_button_text_size" />
                    </RadioGroup>

                    <CheckBox
                        android:id="@+id/com_d_line_break"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_weight="1"
                        android:text="@string/line_break_title"
                        android:textSize="@dimen/check_box_text_size" />
                </LinearLayout>

                <LinearLayout
                    android:layout_width="match_parent"
                    android:layout_height="wrap_content"
                    android:orientation="horizontal">

                    <EditText
                        android:id="@+id/com_d_send_delay"
                        android:layout_width="0dp"
                        android:layout_height="wrap_content"
                        android:layout_weight="1"
                        android:background="@drawable/edit_text_bg"
                        android:imeOptions="actionDone"
                        android:inputType="numberSigned"
                        android:singleLine="true"
                        android:textSize="@dimen/command_edit_text_size" />

                    <TextView
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_marginLeft="@dimen/time_unit_margin_left"
                        android:text="@string/time_unit_title"
                        android:textSize="@dimen/time_unit_text_size" />

                    <CheckBox
                        android:id="@+id/com_d_auto_send"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:text="@string/auto_title"
                        android:textSize="@dimen/check_box_text_size" />

                    <Button
                        android:id="@+id/com_d_send"
                        android:layout_width="@dimen/button_width"
                        android:layout_height="@dimen/button_height"
                        android:text="@string/send_title"
                        android:textSize="@dimen/button_text_size" />
                </LinearLayout>

            </LinearLayout>

        </LinearLayout>

    </LinearLayout>

</LinearLayout>